'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Mutants2 = require('./Mutants');

var _Mutants3 = _interopRequireDefault(_Mutants2);

var _AndroidRestore = require('./AndroidRestore');

var _AndroidRestore2 = _interopRequireDefault(_AndroidRestore);

var _nativeConfig = require('./native-config');

var _nativeConfig2 = _interopRequireDefault(_nativeConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 在chanjet平台上实现的具体预处理类 , 需要监听cordova.deviceready事件
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by tonyjiang on 16/3/17.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var MutantsForChanjet = function (_Mutants) {
    _inherits(MutantsForChanjet, _Mutants);

    function MutantsForChanjet() {
        _classCallCheck(this, MutantsForChanjet);

        return _possibleConstructorReturn(this, (MutantsForChanjet.__proto__ || Object.getPrototypeOf(MutantsForChanjet)).call(this));
    }

    _createClass(MutantsForChanjet, [{
        key: '_ready',
        value: function _ready() {
            document.addEventListener('deviceready', this._deviceReadyHandler.bind(this));
            document.addEventListener('resume', this._deviceResumeHandler.bind(this));
            document.addEventListener('pause', this._deviceSuspendHandler.bind(this));
        }
    }, {
        key: '_deviceReadyHandler',
        value: function _deviceReadyHandler() {
            var _this2 = this;

            // 获取 native config 信息
            this._retrieveNativeConfig().then(function () {
                //如果是安卓, 则需要查询restore状态及数据, 查询完成后, 在进行后续处理
                if (_this2.env.os == _this2.env.constant.os.android) {
                    _AndroidRestore2.default.ready(_this2._readyCallback.bind(_this2));
                } else {
                    _this2._readyCallback();
                }
            }).catch(function (err) {
                console.error(err);
                _this2._readyCallback(err);
            });
        }
    }, {
        key: '_deviceResumeHandler',
        value: function _deviceResumeHandler() {
            this.emitter.emit(_Mutants3.default.EVENT_NAME.RESUME);
        }
    }, {
        key: '_deviceSuspendHandler',
        value: function _deviceSuspendHandler() {
            this.emitter.emit(_Mutants3.default.EVENT_NAME.SUSPEND);
        }
    }, {
        key: '_readyCallback',
        value: function _readyCallback(error) {
            this._isReady = true;
            this.emitter.emit(_Mutants3.default.EVENT_NAME.READY, error);
        }
    }, {
        key: '_retrieveNativeConfig',
        value: function _retrieveNativeConfig() {
            return new Promise(function (resolve, reject) {
                var success = function success(resp) {
                    try {
                        if (typeof resp === 'string') {
                            resp = JSON.parse(resp);
                        }

                        if (resp.data && resp.data.platformExtension && resp.data.platformExtension !== '') {
                            // 解析 config 对象
                            _nativeConfig2.default.parseConfig(resp);
                            resolve(_nativeConfig2.default.instance);
                        } else {
                            reject('没有得到正确的 config 数据.');
                        }
                    } catch (err) {
                        reject(err.toString());
                    }
                };

                var error = function error(_error) {
                    reject(_error);
                };

                if (window.cordova && window.cordova.exec) {
                    // 有 cordova , 调用 native 插件读取 config 信息
                    window.cordova.exec(success, error, 'Config', 'getConfig', []);
                } else {
                    reject('没有 cordova 对象, 请确认 cordova 初始化是否正确.');
                }
            });
        }
    }, {
        key: 'isRestore',
        get: function get() {
            return _AndroidRestore2.default.isRestore;
        }
    }, {
        key: 'restorePluginData',
        get: function get() {
            return _AndroidRestore2.default.restorePluginData;
        }
    }]);

    return MutantsForChanjet;
}(_Mutants3.default);

exports.default = MutantsForChanjet;