/**
 * Created by TonyJiang on 16/4/28.
 */
import 'should';
import chai from 'chai';
const {assert} = chai;

import {PluginMocker} from 'chanjet-plugin-base';
import AuthPlugin from 'chanjet-plugin-auth';
import ChoosePhotoPlugin from 'chanjet-plugin-choose-photo';
import TakePhotoPlugin from 'chanjet-plugin-take-photo';
import GeoPlugin from 'chanjet-plugin-geo';
import PhoneCallPlugin from 'chanjet-plugin-phone-call';
import PreviewPlugin from 'chanjet-plugin-preview';
import RestoreStatusPlugin from 'chanjet-plugin-restore-status';
import SharePlugin from 'chanjet-plugin-share';
import SMSPlugin from 'chanjet-plugin-sms';
import SpeechRecoPlugin from 'chanjet-plugin-speech-reco';
import UploadPlugin from 'chanjet-plugin-upload';

import PluginManager from '../src/PluginManager';


const checkApiMap = {
    //企业信息
    auth : {
        class : AuthPlugin,
        label : 'AuthPlugin'
    },

    //选照片
    choosePhoto :{
        class : ChoosePhotoPlugin,
        label : 'ChoosePhotoPlugin'
    },
    //拍照
    takePhoto : {
        class : TakePhotoPlugin,
        label : 'TakePhotoPlugin'
    },
    //预览
    preview : {
        class : PreviewPlugin,
        label : 'PreviewPlugin'
    },
    //上传
    upload : {
        class : UploadPlugin,
        label : 'UploadPlugin'
    },

    //定位
    geo : {
        class : GeoPlugin,
        label : 'GeoPlugin'
    },

    //打电话
    phone : {
        class : PhoneCallPlugin,
        label : 'PhoneCallPlugin'
    },

    //短信
    sms : {
        class : SMSPlugin,
        label : 'SMSPlugin'
    },

    //分享
    share : {
        class : SharePlugin,
        label : 'SharePlugin'
    },

    //语音识别
    speechReco : {
        class : SpeechRecoPlugin,
        label : 'SpeechRecoPlugin'
    },

    //android restore状态查询
    restoreStatus : {
        class : RestoreStatusPlugin,
        label : 'RestoreStatusPlugin'
    }
};

const mockData = {
    ChoosePhotoPlugin : {
        status : 'success',
        data : ['http://www.example.com/1.png']
    }
};

describe('PluginManager 单元测试' , () => {


    describe('验证插件是否匹配对应类' , () => {
        for(let prop in checkApiMap){
            let api = checkApiMap[prop];

            it('PluginManager.' + prop + ' 应该是 ' + api.label + ' 的实例' , () => {
                assert(PluginManager[prop] instanceof api.class);
            });

        }
    });

    it('验证mock数据设置成功' , () => {
        PluginManager.setMockData(mockData);
        assert(PluginMocker.data.should.equal(mockData));
    });


});